
proc quit_when_dead {w} { 
    set children [winfo children .]
    if {[llength $children] <= 1 && "$w" != ""} { 
	exit 0
    }
}


proc startup {} { 
    global  argv0 \
	    Font \
	    HeaderFont \
	    FontSize \
	    HeaderFontSize \
	    Maxheight \
	    Maxwidth \
	    Nrows_default \
	    Pf \
	    Readable_epoch_time \
	    Wcnt \
	    env 


    global argc argv
    if { $argc < 1 } {
	puts stderr "Usage: dbe \[-e] \[-p pf-file] database\[.table\] \[database\[.table\] ...\]"
	exit
    } 

    bind Resizable <Destroy> "quit_when_dead %W"
    bind Toplevel <Destroy> "quit_when_dead %W"
    
    regsub {.*/} $argv0 "" argv0
    set Pf .$argv0
    set i 0
    set n [llength $argv] 
    set new_argv {}

    pfgetarr fonts [pfget $Pf fonts]
    foreach font [array names fonts] { 
	eval font create $font $fonts($font)
    }
    option add *Font Button

    global Editok_default
    set Editok_default 0
    set specify_fields 0
    set fields {}
    while { $i < $n } {
	set arg [lindex $argv $i]
	if { [cequal $arg -e] } {
	    set Editok_default 1
	} elseif { [cequal $arg -p] } {
	    incr i
	    set Pf [lindex $argv $i]
	} elseif { [cequal $arg -f] } { 
	    set specify_fields 1
	} else {
	    if { $specify_fields } { 
		lappend fields $arg
	    } else {
		lappend new_argv $arg
	    }
	}
	incr i
    }
    set argv $new_argv

    if { [info exists env(PFPATH)] } { 
	set save $env(PFPATH)
    }

    if { [info exists env(PFPATH)] } { 
	set env(PFPATH) $env(ANTELOPE)/data/pf:$env(PFPATH):.:$env(HOME)
    } else { 
	set env(PFPATH) $env(ANTELOPE)/data/pf:.:$env(HOME)
    }
    
    if { [catch {pfread $Pf} error] } { 
	if { $error != "" } { 
	    puts stderr " *** Can't read the parameter file '$Pf':\n\t$error" 
	} else { 
	    puts stderr " *** Can't read the parameter file '$Pf'" 
	}
	exit 1 
    }

    if { [info exists save] } { 
	set env(PFPATH) $save
    } else { 
	unset env(PFPATH)
    }

    if { [boolean [pfget $Pf rebind_listbox]] } { 
	rebind_listbox
    }

    set Wcnt 0
    set Nrows_default [pfget $Pf Records_to_display]
    set maxpf [pfget $Pf maximum_width]
    set maxw [expr [winfo vrootwidth .] - 50]
    if [expr $maxw > $maxpf] {
	set Maxwidth(.) $maxpf
    } else { 
	set Maxwidth(.) $maxw
    }
    set Maxheight(.) [expr [winfo vrootheight .]-50]
    set Font [pfget $Pf Font]
    set FontSize [pfget $Pf FontSize]
    set HeaderFont [pfget $Pf HeaderFont]
    set HeaderFontSize [pfget $Pf HeaderFontSize]
    option add *Font $HeaderFont

    compute_charsize

    global Hide_duplicate_columns Hide_null_columns
    set Hide_duplicate_columns(.) [boolean [pfget $Pf Hide_duplicate_columns]]
    set Hide_null_columns(.) [boolean [pfget $Pf Hide_null_columns]]
    set Readable_epoch_time(.) [boolean [pfget $Pf Readable_epoch_time]]
    global Maximum_column_width
    set Maximum_column_width [pfget $Pf Maximum_column_width]

    wm withdraw . 
    foreach database $argv {
	regsub -all //+ $database / database
	regsub -all /\\./ $database / database
	if { [llength $fields] > 0 } {  
	    database_show $database $fields
	} else { 
	    database_show $database 
	}
    }
    quit_when_dead ""
}

